#ifndef _SPI_SETUP_H_
#define _SPI_SETUP_H_

#include "LS7366.h"

SPI spi1(SPI_MOSI, SPI_MISO, SPI_SCK);

LS7366 encoder1(spi1, ENCODER_CS1); 
LS7366 encoder2(spi1, ENCODER_CS2);
LS7366 encoder3(spi1, ENCODER_CS3);
LS7366 encoder4(spi1, ENCODER_CS4);
LS7366 encoder5(spi1, ENCODER_CS5);
LS7366 encoder6(spi1, ENCODER_CS6);
DigitalOut at_spi_cs(PB_4);
DigitalOut st16_spi_cs(PB_5);

DigitalOut seg_cs(PA_0);
DigitalOut btn1_cs(PA_11);
DigitalOut btn2_cs(PA_12);



void spi_init()
{
    spi1.format(8,0);
    spi1.frequency(2000000);
    seg_cs = 0;
    btn1_cs = 0;
    btn2_cs = 0;
}

#endif